Subject: Re: [RFC PATCH 08/11] IB/Verbs: Use management helper has_iwarp() for, iwarp-check

From: Michael Wang <[email-masked]>
Date: Tue, 31 Mar 2015 15:58:52 +0200

On 03/31/2015 03:42 PM, Tom Talpey wrote:

> On 3/31/2015 7:41 AM, Michael Wang wrote:
>> [snip]
> Yes, in fact the iWARP protocol does not preclude multiple read SGEs,
> even though most iWARP implementations have chosen to support just one.
>
> Even for multi-SGE-capable adapters, there is a limit of SGL size, based
> on the adapter's work request format and other factors. So my argument
> is that upper layers can and should query that, not make a blanket
> decision based on protocol type.

Thanks for the explanation  Sounds like some new callback on device level
like query_device() to acquire the right info.

>> I currently only find this one place where infer max-read-sges from
>> transport type, it looks more like a special case to me rather than a generic
>> method we could exposed... and also  not very related with IB management
>> helper concept IMHO.
> It is most certainly not a special case, but you could decide to
> introduce it in many ways. I'm not commenting on that.
>
> My main concern is that you do not introduce a new and clumsy "is iWARP"
> rule as an adapter-specific API requirement to expose the RDMA Read SGE
> behavior. That's what your initial message seemed to imply?

Yeah I planed to just use rdma_transport_iwarp() to replace the check, it's
actually meaningless but just refine, frankly speaking I would prefer some
driver developer to work on that part, at this point I prefer to focus on
introducing the management helpers firstly 

Maybe we could mark it as a TODO temporarily, if later we found more
scenes using similar logical, we can collect them and do some reform 

Regards,
Michael Wang